"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVsGeneticChecks(ProtocolElement):
    """
    Reported versus Genetic checks object
    ========================================
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import metrics as metrics_1_3_0

        return {
            "coverageBasedSex": metrics_1_3_0.CoverageBasedSex,
            "evaluation": metrics_1_3_0.Evaluation,
            "familyRelatedness": metrics_1_3_0.FamilyRelatedness,
            "mendelianInconsistencies": metrics_1_3_0.MendelianInconsistencies,
            "reportedVsGeneticSummary": metrics_1_3_0.ReportedVsGeneticSummary,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import metrics as metrics_1_3_0

        return {
            "org.gel.models.metrics.avro.CoverageBasedSex": metrics_1_3_0.CoverageBasedSex,
            "org.gel.models.metrics.avro.Evaluation": metrics_1_3_0.Evaluation,
            "org.gel.models.metrics.avro.FamilyRelatedness": metrics_1_3_0.FamilyRelatedness,
            "org.gel.models.metrics.avro.MendelianInconsistencies": metrics_1_3_0.MendelianInconsistencies,
            "org.gel.models.metrics.avro.ReportedVsGeneticSummary": metrics_1_3_0.ReportedVsGeneticSummary,
            "org.gel.models.metrics.avro.ReportedVsGeneticChecks": metrics_1_3_0.ReportedVsGeneticChecks,
        }

    __slots__ = [
        "coverageBasedSex",
        "evaluation",
        "familyRelatedness",
        "mendelianInconsistencies",
        "reportedVsGeneticSummary",
    ]

    def __init__(
        self,
        coverageBasedSex=None,
        evaluation=None,
        familyRelatedness=None,
        mendelianInconsistencies=None,
        reportedVsGeneticSummary=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_3_0.ReportedVsGeneticChecks model.

        :param coverageBasedSex:
            Coverage-based sex metrics and inferred karyotype
        :type coverageBasedSex: None | list[CoverageBasedSex]
        :param evaluation:
            Evaluation of the reported vs genetic information
        :type evaluation: None | Evaluation
        :param familyRelatedness:
            Within-family relatedness
        :type familyRelatedness: None | FamilyRelatedness
        :param mendelianInconsistencies:
            Per family and per sample mendelian inconsistencies
        :type mendelianInconsistencies: None | MendelianInconsistencies
        :param reportedVsGeneticSummary:
            Summary of the software, versions and samples used for the RvsG checks
        :type reportedVsGeneticSummary: None | ReportedVsGeneticSummary
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
